## ros-noetic-ublox-gps 1.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(ublox_gps)
find_package(catkin REQUIRED COMPONENTS
  tf
  roscpp
  roscpp_serialization
  ublox_msgs
  ublox_serialization
  diagnostic_updater
  rtcm_msgs
)

catkin_package(
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME}
    CATKIN_DEPENDS tf roscpp ublox_msgs ublox_serialization rtcm_msgs)

# include boost
find_package(Boost REQUIRED COMPONENTS system regex thread)
link_directories(${Boost_LIBRARY_DIR})
include_directories(${Boost_INCLUDE_DIR})

# include other ublox packages
include_directories(${PROJECT_SOURCE_DIR}/include)
include_directories(${catkin_INCLUDE_DIRS})

# link pthread
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -std=c++11 -pthread")

# build library
add_library(ublox_gps src/gps.cpp)

# fix msg compile order bug
add_dependencies(ublox_gps ${catkin_EXPORTED_TARGETS})

target_link_libraries(ublox_gps
  boost_system
  boost_regex
  boost_thread
)

target_link_libraries(ublox_gps
  ${catkin_LIBRARIES}
)

# build node
add_executable(ublox_gps_node src/node.cpp src/mkgmtime.c src/raw_data_pa.cpp)
set_target_properties(ublox_gps_node PROPERTIES OUTPUT_NAME ublox_gps)

target_link_libraries(ublox_gps_node boost_system boost_regex boost_thread)
target_link_libraries(ublox_gps_node ${catkin_LIBRARIES})
target_link_libraries(ublox_gps_node ublox_gps)

# build logger node
add_executable(ublox_logger_node src/logger_node_pa.cpp src/raw_data_pa.cpp)
set_target_properties(ublox_logger_node PROPERTIES OUTPUT_NAME ublox_logger)

target_link_libraries(ublox_logger_node ${catkin_LIBRARIES})

install(TARGETS ublox_gps ublox_gps_node ublox_logger_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  PATTERN ".svn" EXCLUDE
)

install(DIRECTORY config/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/config
  PATTERN ".svn" EXCLUDE
)

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  PATTERN ".svn" EXCLUDE
)

=== debian/changelog ===
ros-noetic-ublox-gps (1.5.0-1buster) buster; urgency=high

  * Add rtcm_msgs dependency
  * Add RTK support via rtcm
  * GPS coordinate precision corrected for high accuracy.
  * Diagonstics for Differential GNSS updated.
  * Add a new parameter to set the search path for the param_file_name. Add a default to the node_name parameter.
  * Add zed-f9p configuration
  * Contributors: Balamurugan Kandan, Chris Iverach-Brereton, Igor

 -- Gareth Cross <gcross.code@icloud.com>  Thu, 14 Oct 2021 22:00:00 -0000

ros-noetic-ublox-gps (1.4.1-1buster) buster; urgency=high

  * fix signs in sensor_msgs::Imu output
  * Contributors: Raphael Riebl

 -- Gareth Cross <gcross.code@icloud.com>  Wed, 03 Jun 2020 22:00:00 -0000

ros-noetic-ublox-gps (1.4.0-1buster) buster; urgency=high

  * Bump CMake minimum version to 3.0.2
  * Move variables from .h to .cpp to solve linking issues
  * added support for protocol version >= 18
  * Contributors: Firat Kasmis, Gonçalo Pereira

 -- Gareth Cross <gcross.code@icloud.com>  Wed, 27 May 2020 22:00:00 -0000

ros-noetic-ublox-gps (1.3.1-1buster) buster; urgency=high

  * Fix unit in covariance calculation
  * Contributors: Ferry Schoenmakers

 -- Gareth Cross <gcross.code@icloud.com>  Wed, 11 Mar 2020 23:00:00 -0000

ros-noetic-ublox-gps (1.3.0-1buster) buster; urgency=high

  * Fix heading output to comply with REP-103
    When not reporting valid heading, overwrite covariance with big number (0 otherwise)
  * CfgNAV5: add dynamic model bike
  * Contributors: Ferry Schoenmakers, Raphael Riebl

 -- Gareth Cross <gcross.code@icloud.com>  Thu, 09 Jan 2020 23:00:00 -0000

ros-noetic-ublox-gps (1.2.0-1buster) buster; urgency=high

  * Add support for ZED-F9P new RELPOSNED message and provide heading output
    Fix whitespacing...
    Add RELPOSNED9 message to compile
  * Fix for corrupted diagnostics messages
    Before the diagnostic structs were copied, but the pointers in FrequencyStatusParams still pointed to the old/freed objects.
  * Show TMODE3 diagnostics OK if disabled
    Since there is no default for TMODE3 this is a deliberate choice
  * added simple (remote) logger node for raw data stream logging
  * updated raw data stream logging
    + moved all global/node functions to new class RawDataStreamPa
    (raw_data_pa .h/.c)
    + changed messagetype to uint8-multiarray
    (string can not handle non-characters)
  * fix #52 <https://github.com/KumarRobotics/ublox/issues/52>
  * FIX: overflow bug when the nano field of the NavPVT message (which is signed and can be negative) is assigned to the nsec value of a ros time stamp (which is unsigned)
  * deactivated config checks for base parts, if config_on_startup is false
  * Added flag config_on_startup to deactivate configuration of ublox.
  * fixes to raw data stream
    + moving write_callback_ before the read_callback_, to avoid buffer copying
    (write_callback_ == publishing ros messages and writing to file)
    + publishing empty ros message during config phase to force instantiation
    of publisher
  * renamed new topic and internal variables for raw data stream
    + from raw_data_xxx to raw_data_stream_xxx
    + this is to avoid confusion with the RawDataProduct
  * updated debug message for measurement rate
    (added "hz" and "cycles" as units)
  * TUC-ProAut: added raw data output
    (publishing ros messages and storing to file)
  * boost::posix_time::seconds constructor requires integer argument
  * Add TIM product and M8U functionality as well as the TIM-TM2 message (#27 <https://github.com/KumarRobotics/ublox/issues/27>)
  * Initialize set_usb_ to false by default
  * Set serial port to raw mode, needed for Boost versions < 1.66.0
  * Minor fixes for very old devices
  * Fix potential segfault when printing Inf messages
    The Inf message strings are not null terminated, so we need to construct
    the string of the correct size from the vector of bytes instead of just
    printing using %s.
  * In AsyncWorker::doClose(), close the stream instead of just cancelling operations
  * Cleanup + modernize to make compatible with C++11
  * Fix compilation with newer GCC and Boost
    As of now, doesn't compile with C++11 or later.
  * added clear params arg
  * updated config files
  * added save and load configuration parameters and functions. changed how GNSS is configured & reset.
  * added raw data product class and structs for frequency diagnostics
  * Contributors: Chao Qu, Evan Flynn, Ferry Schoenmakers, Kartik Mohta, Michael Stoll, Peter Weissig, Stewart Worrall, Tim Clephas, Veronica Lane

 -- Gareth Cross <gcross.code@icloud.com>  Mon, 18 Nov 2019 23:00:00 -0000

ros-noetic-ublox-gps (1.1.2-1buster) buster; urgency=high

  * README and package xml updates
  * Fixed bug with enabling INF messages. Changed how messages which update fix are enabled and changed name of subscribe param namespace to publish.
  * added USB Cfg PRT parameters and configuration
  * Changed how I/O is initialized so that u-blox node parses the device parameter, and then calls either initializeSerial or initializeTcp in the GPS class with the appropriate parameters. Also cleaned up doxygen comments
  * Added doxygen comments and made minor cleanup changes.
  * Added doxygen comments
  * Fixed bug with ARP Position HP conversion, which was multiplied by the wrong conversion factor. The ARP Position HP parameter is now an int8 vector instead of a float vector. Also added a getRosInt method in the node to get int8 and int16 params and changed the name of getRosParam to getRosUint.
  * removing unnecessary include
  * Changed how ACKs are handled. They are now handled through callback functions and are included in the CallbackHandlers.
  * Created a CallbackHandlers class and migrated callbacks functionality from Gps class to the CallbackHandlers class
  * Node can now save flash memory on shutdown and clear flash memory based on user params


=== debian/control ===
Source: ros-noetic-ublox-gps
Section: misc
Priority: optional
Maintainer: Gareth Cross <gcross.code@icloud.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-roscpp, ros-noetic-roscpp-serialization, ros-noetic-rtcm-msgs, ros-noetic-tf, ros-noetic-ublox-msgs, ros-noetic-ublox-serialization
Homepage: http://ros.org/wiki/ublox
Standards-Version: 3.9.2

Package: ros-noetic-ublox-gps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-diagnostic-updater, ros-noetic-roscpp, ros-noetic-roscpp-serialization, ros-noetic-rtcm-msgs, ros-noetic-tf, ros-noetic-ublox-msgs, ros-noetic-ublox-serialization
Description: Driver for u-blox GPS devices.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-ublox-gps//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
